DoubleBinding (JavaFX 13)

Module javafx.base
Package javafx.beans.binding

## Class DoubleBinding

- java.lang.Object
- - javafx.beans.binding.NumberExpressionBase
  - - javafx.beans.binding.DoubleExpression
    - - javafx.beans.binding.DoubleBinding

- All Implemented Interfaces:
    `Binding<Number>`, `NumberBinding`, `NumberExpression`, `Observable`, `ObservableDoubleValue`, `ObservableNumberValue`, `ObservableValue<Number>`

      public abstract class DoubleBinding
      extends DoubleExpression
      implements NumberBinding

  Base class that provides most of the functionality needed to implement a `Binding` of a `double` value.

  `DoubleBinding` provides a simple invalidation-scheme. An extending class can register dependencies by calling `bind(Observable...)`. If One of the registered dependencies becomes invalid, this `DoubleBinding` is marked as invalid. With `unbind(Observable...)` listening to dependencies can be stopped.

  To provide a concrete implementation of this class, the method `computeValue()` has to be implemented to calculate the value of this binding based on the current state of the dependencies. It is called when `get()` is called for an invalid binding.

  Below is a simple example of a `DoubleBinding` calculating the square- root of a `ObservableNumberValue` `moo`.

       final ObservableDoubleValue moo = ...;

       DoubleBinding foo = new DoubleBinding() {

           {
               super.bind(moo);
           }

           @Override
           protected double computeValue() {
               return Math.sqrt(moo.getValue());
           }
       };

  Following is the same example with implementations for the optional methods `Binding.getDependencies()` and `Binding.dispose()`.

       final ObservableDoubleValue moo = ...;

       DoubleBinding foo = new DoubleBinding() {

           {
               super.bind(moo);
           }

           @Override
           protected double computeValue() {
               return Math.sqrt(moo.getValue());
           }

           @Override
           public ObservableList<?> getDependencies() {
               return FXCollections.singletonObservableList(moo);
           }

           @Override
           public void dispose() {
               super.unbind(moo);
           }
       };

  Since:
    JavaFX 2.0
  See Also:
    `Binding`, `NumberBinding`, `DoubleExpression`

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `DoubleBinding()` |

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `addListener​(InvalidationListener listener)` | Adds an `InvalidationListener` which will be notified whenever the `Observable` becomes invalid.
    `void` | `addListener​(ChangeListener<? super Number> listener)` | Adds a `ChangeListener` which will be notified whenever the value of the `ObservableValue` changes.
    `protected void` | `bind​(Observable... dependencies)` | Start observing the dependencies for changes.
    `protected abstract double` | `computeValue()` | Calculates the current value of this binding.
    `void` | `dispose()` | A default implementation of `dispose()` that is empty.
    `double` | `get()` | Returns the result of `computeValue()`.
    `ObservableList<?>` | `getDependencies()` | A default implementation of `getDependencies()` that returns an empty `ObservableList`.
    `void` | `invalidate()` | Mark a binding as invalid.
    `boolean` | `isValid()` | Checks if a binding is valid.
    `protected void` | `onInvalidating()` | The method onInvalidating() can be overridden by extending classes to react, if this binding becomes invalid.
    `void` | `removeListener​(InvalidationListener listener)` | Removes the given listener from the list of listeners, that are notified whenever the value of the `Observable` becomes invalid.
    `void` | `removeListener​(ChangeListener<? super Number> listener)` | Removes the given listener from the list of listeners that are notified whenever the value of the `ObservableValue` changes.
    `String` | `toString()` | Returns a string representation of this `DoubleBinding` object.
    `protected void` | `unbind​(Observable... dependencies)` | Stop observing the dependencies for changes.

    - ### Methods inherited from class javafx.beans.binding.DoubleExpression

      `add, add, add, add, add, asObject, divide, divide, divide, divide, divide, doubleExpression, doubleExpression, doubleValue, floatValue, getValue, intValue, longValue, multiply, multiply, multiply, multiply, multiply, negate, subtract, subtract, subtract, subtract, subtract`

    - ### Methods inherited from class javafx.beans.binding.NumberExpressionBase

      `asString, asString, asString, greaterThan, greaterThan, greaterThan, greaterThan, greaterThan, greaterThanOrEqualTo, greaterThanOrEqualTo, greaterThanOrEqualTo, greaterThanOrEqualTo, greaterThanOrEqualTo, isEqualTo, isEqualTo, isEqualTo, isEqualTo, isEqualTo, isEqualTo, isEqualTo, isEqualTo, isNotEqualTo, isNotEqualTo, isNotEqualTo, isNotEqualTo, isNotEqualTo, isNotEqualTo, isNotEqualTo, isNotEqualTo, lessThan, lessThan, lessThan, lessThan, lessThan, lessThanOrEqualTo, lessThanOrEqualTo, lessThanOrEqualTo, lessThanOrEqualTo, lessThanOrEqualTo, numberExpression`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface javafx.beans.binding.NumberExpression

      `add, add, add, add, add, asString, asString, asString, divide, divide, divide, divide, divide, greaterThan, greaterThan, greaterThan, greaterThan, greaterThan, greaterThanOrEqualTo, greaterThanOrEqualTo, greaterThanOrEqualTo, greaterThanOrEqualTo, greaterThanOrEqualTo, isEqualTo, isEqualTo, isEqualTo, isEqualTo, isEqualTo, isEqualTo, isEqualTo, isEqualTo, isNotEqualTo, isNotEqualTo, isNotEqualTo, isNotEqualTo, isNotEqualTo, isNotEqualTo, isNotEqualTo, isNotEqualTo, lessThan, lessThan, lessThan, lessThan, lessThan, lessThanOrEqualTo, lessThanOrEqualTo, lessThanOrEqualTo, lessThanOrEqualTo, lessThanOrEqualTo, multiply, multiply, multiply, multiply, multiply, negate, subtract, subtract, subtract, subtract, subtract`

    - ### Methods inherited from interface javafx.beans.value.ObservableNumberValue

      `doubleValue, floatValue, intValue, longValue`

    - ### Methods inherited from interface javafx.beans.value.ObservableValue

      `getValue`

- - ### Constructor Detail

    - #### DoubleBinding

          public DoubleBinding()

  - ### Method Detail

    - #### addListener

          public void addListener​(InvalidationListener listener)

      Description copied from interface: `Observable`
      Adds an `InvalidationListener` which will be notified whenever the `Observable` becomes invalid. If the same listener is added more than once, then it will be notified more than once. That is, no check is made to ensure uniqueness.

      Note that the same actual `InvalidationListener` instance may be safely registered for different `Observables`.

      The `Observable` stores a strong reference to the listener which will prevent the listener from being garbage collected and may result in a memory leak. It is recommended to either unregister a listener by calling `removeListener` after use or to use an instance of `WeakInvalidationListener` avoid this situation.

      Specified by:
        `addListener` in interface `Observable`
      Parameters:
        `listener` - The listener to register
      See Also:
        `Observable.removeListener(InvalidationListener)`

    - #### removeListener

          public void removeListener​(InvalidationListener listener)

      Description copied from interface: `Observable`
      Removes the given listener from the list of listeners, that are notified whenever the value of the `Observable` becomes invalid.

      If the given listener has not been previously registered (i.e. it was never added) then this method call is a no-op. If it had been previously added then it will be removed. If it had been added more than once, then only the first occurrence will be removed.

      Specified by:
        `removeListener` in interface `Observable`
      Parameters:
        `listener` - The listener to remove
      See Also:
        `Observable.addListener(InvalidationListener)`

    - #### addListener

          public void addListener​(ChangeListener<? super Number> listener)

      Description copied from interface: `ObservableValue`
      Adds a `ChangeListener` which will be notified whenever the value of the `ObservableValue` changes. If the same listener is added more than once, then it will be notified more than once. That is, no check is made to ensure uniqueness.

      Note that the same actual `ChangeListener` instance may be safely registered for different `ObservableValues`.

      The `ObservableValue` stores a strong reference to the listener which will prevent the listener from being garbage collected and may result in a memory leak. It is recommended to either unregister a listener by calling `removeListener` after use or to use an instance of `WeakChangeListener` avoid this situation.

      Specified by:
        `addListener` in interface `ObservableValue<Number>`
      Parameters:
        `listener` - The listener to register
      See Also:
        `ObservableValue.removeListener(ChangeListener)`

    - #### removeListener

          public void removeListener​(ChangeListener<? super Number> listener)

      Description copied from interface: `ObservableValue`
      Removes the given listener from the list of listeners that are notified whenever the value of the `ObservableValue` changes.

      If the given listener has not been previously registered (i.e. it was never added) then this method call is a no-op. If it had been previously added then it will be removed. If it had been added more than once, then only the first occurrence will be removed.

      Specified by:
        `removeListener` in interface `ObservableValue<Number>`
      Parameters:
        `listener` - The listener to remove
      See Also:
        `ObservableValue.addListener(ChangeListener)`

    - #### bind

          protected final void bind​(Observable... dependencies)

      Start observing the dependencies for changes. If the value of one of the dependencies changes, the binding is marked as invalid.
      Parameters:
        `dependencies` - the dependencies to observe

    - #### unbind

          protected final void unbind​(Observable... dependencies)

      Stop observing the dependencies for changes.
      Parameters:
        `dependencies` - the dependencies to stop observing

    - #### dispose

          public void dispose()

      A default implementation of `dispose()` that is empty.
      Specified by:
        `dispose` in interface `Binding<Number>`

    - #### getDependencies

          public ObservableList<?> getDependencies()

      A default implementation of `getDependencies()` that returns an empty `ObservableList`.
      Specified by:
        `getDependencies` in interface `Binding<Number>`
      Returns:
        an empty `ObservableList`

    - #### get

          public final double get()

      Returns the result of `computeValue()`. The method `computeValue()` is only called if the binding is invalid. The result is cached and returned if the binding did not become invalid since the last call of `get()`.
      Specified by:
        `get` in interface `ObservableDoubleValue`
      Returns:
        the current value

    - #### onInvalidating

          protected void onInvalidating()

      The method onInvalidating() can be overridden by extending classes to react, if this binding becomes invalid. The default implementation is empty.

    - #### invalidate

          public final void invalidate()

      Description copied from interface: `Binding`
      Mark a binding as invalid. This forces the recalculation of the value of the `Binding` next time it is request.
      Specified by:
        `invalidate` in interface `Binding<Number>`

    - #### isValid

          public final boolean isValid()

      Description copied from interface: `Binding`
      Checks if a binding is valid.
      Specified by:
        `isValid` in interface `Binding<Number>`
      Returns:
        `true` if the `Binding` is valid, `false` otherwise

    - #### computeValue

          protected abstract double computeValue()

      Calculates the current value of this binding.

      Classes extending `DoubleBinding` have to provide an implementation of `computeValue`.

      Returns:
        the current value

    - #### toString

          public String toString()

      Returns a string representation of this `DoubleBinding` object.
      Overrides:
        `toString` in class `Object`
      Returns:
        a string representation of this `DoubleBinding` object.